//------------------------------//
//        Fizty by IKI          //
//                              //
// Last  Version: 06. Dec. 2000 //
//------------------------------//

#include "Fitzy.h"
 
extern u32 spr_data;
extern u32 sprite_palette;
extern u32 back_data;
extern u32 back_palette;

u16 Patterns[][4]=
{
	{ 0,0,0,0, },
	{ 0,0,1,1, },
	{ 2,3,4,5, },
	{ 6,7,8,9, },
	{ 10,11,12,13, },
};

u8 MyMap[16][16] =
{
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,
	0,2,0,0,2,2,2,2,2,2,2,2,0,0,2,0,
	0,2,1,1,2,2,2,2,2,2,2,2,1,1,2,0,
	0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,
	0,2,2,2,2,0,1,2,2,1,0,2,2,2,2,0,
	0,2,2,2,2,1,2,2,2,2,1,2,2,2,2,0,
	0,2,2,2,2,2,2,4,4,2,2,2,2,2,2,0,
	0,2,2,2,2,2,2,4,4,2,2,2,2,2,2,0,
	0,2,2,2,2,0,2,2,2,2,0,2,2,2,2,0,
	0,2,2,2,2,1,1,2,2,1,1,2,2,2,2,0,
	0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,
	0,2,0,0,2,2,2,2,2,2,2,2,0,0,2,0,
	0,2,1,1,2,2,2,2,2,2,2,2,1,1,2,0,
	0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
};

void DMA3Call(u32 Src,u32 Dst,u32 Cnt)
{
	DMA3SAD = Src;
	DMA3DAD = Dst;
	DMA3CNT = Cnt;
}

void SetPrincipalActorInfo(u16 x,u16 y,u8 i)
{
	OAM[0].Attrib0 = 0x2000+y;
	OAM[0].Attrib1 = x;
	OAM[0].Attrib2 = (i<<2);

	OAM[1].Attrib0 = 0x2000+y;;
	OAM[1].Attrib1 = x+8;
	OAM[1].Attrib2 = (i<<2)+2;
	
	OAM[2].Attrib0 = 0x2008+y;
	OAM[2].Attrib1 = x;
	OAM[2].Attrib2 = (i<<2)+48;
	
	OAM[3].Attrib0 = 0x2008+y;
	OAM[3].Attrib1 = x+8;
	OAM[3].Attrib2 = (i<<2)+50;

	OAM[4].Attrib0 = 0x2010+y;
	OAM[4].Attrib1 = x;
	OAM[4].Attrib2 = (i<<2)+96;

	OAM[5].Attrib0 = 0x2010+y;
	OAM[5].Attrib1 = x+8;
	OAM[5].Attrib2 = (i<<2)+98;
}

void Init()
{
	u16 i,j;

	DMA3Call((u32)&back_palette, (u32)BG_PLTT,  0x84000080);	// Setup the background palette
	DMA3Call((u32)&sprite_palette, (u32)OBJ_PLTT, 0x84000080);	// Setup the sprites palette
	DMA3Call((u32)&back_data, 0x6004000, 0x84000100);		// Copy Background Character Bloc to VRAM
	DMA3Call((u32)&spr_data, (u32)OBJCHARDATA, 0x84000480);		// Copy Sprites Character Bloc to VRAM

// Setup BG0 Character Base Bloc 0x06004000 and Screen Base Bloc 0x06000000 and the 256 colors palette
// Emulator does not seem to support Mosaic mode ((
	BG0CNT = 0x0084;
//	MOSAIC = 0x0011;

// Sets video mode to 0 with BG0 and OBJ on. 1 Dimensional OBJ mode
	DISPCNT = 0x1140;

	for (j=0;j<16;j++)
		for (i=0;i<16;i++)
		{
			VBUFFER[i*2+j*64]= Patterns[MyMap[j][i]][0];
			VBUFFER[i*2+j*64+1]= Patterns[MyMap[j][i]][1];
			VBUFFER[i*2+j*64+32]= Patterns[MyMap[j][i]][2];
			VBUFFER[i*2+j*64+33]= Patterns[MyMap[j][i]][3];
		}
		
	for (i=0; i<256;++i)
	{
		OAM[i].Attrib0 = 252; // y=64
		OAM[i].Attrib1 = 508; // x=128
	}

	SetPrincipalActorInfo(128,64,9);

}

#define GAUCHE 0
#define DROITE 1
#define HAUT 2
#define BAS 3

u8 TestCase(s16 _x,s16 _y)
{
	return (MyMap[(_y+16)/16][(_x)/16]==2) && (MyMap[(_y+16)/16][1+(_x-1)/16]==2) &&
	 (MyMap[1+(_y+7)/16][(_x)/16]==2) && (MyMap[1+(_y+7)/16][1+(_x-1)/16]==2);
}

void C_Entry()
{
 	u16 x=128, y=50, old_x, old_y, new_x, new_y, i, x_dir=0, y_dir=0, dir=GAUCHE, phase=0;
 
	Init();

	while (1)
	{
		i=joypad();
		if (i)
		{
			old_x = x;
			old_y = y;
			new_x = x;
			new_y = y;
			
			if (!(i & J_LEFT))	{	x_dir = GAUCHE;	new_x = x-1;	}
			if (!(i & J_RIGHT))	{	x_dir = DROITE;	new_x = x+1;	}
			if (!(i & J_UP))	{	y_dir = HAUT;	new_y = y-1;	}
			if (!(i & J_DOWN))	{	y_dir = BAS;	new_y = y+1;	}
	
			if ((x!=new_x) && TestCase(new_x,y) )	{	x = new_x;	dir = x_dir;	}
			if ((y!=new_y) && TestCase(x,new_y) )	{	y = new_y;	dir = y_dir;	}
	
			if ((x!=old_x) || (y!=old_y))	phase = (phase + 1) % 4;
	
		}
		WaitForVSync();
	
		BG0HOFS = (x-16)*(256L-240L)/208;
		BG0VOFS = y*(256L-160L)/216;
		SetPrincipalActorInfo(x-BG0HOFS,y-BG0VOFS,dir*3+(phase==3?1:phase));
	}
  
 }